//     Author: Maurizio Loreti, aka MLO or (HAM) I3NOO
//     Work:   University of Padova - Department of Physics
//             Via F. Marzolo, 8 - 35131 PADOVA - Italy
//     Phone:  +39 (049) 827-7216   FAX: +39 (049) 827-7102
//     EMail:  loreti@pd.infn.it
//     WWW:    http://www.pd.infn.it/~loreti/mlo.html
//
// -------------------------------------------------------------
//
// $Id: card.cxx,v 1.5 2005/01/21 07:15:43 loreti Exp $
//
// Additional (non-inline) methods and static constants for the
// "card" and "pack" classes, defined in "card.hh".
//
// -------------------------------------------------------------

#include <iterator>
#include "card.hh"

using namespace std;

const char card::suitName[card::numSuits] = {
  's', 'b', 'c', 'd'
};
const char card::valueName[card::maxValue + 1] = {
  '-', 'A', '2', '3', '4', '5', '6', '7', 'F', 'C', 'R'
};

void card::out(
  ostream &o
) const {
  o << '(' << suitName[suit_] << valueName[value_] << ')';
}

pack::pack() {
  cards_.reserve(card::totCards);

  for (unsigned int ui = 0;   ui < card::totCards;   ui++) {
    cards_.push_back(ui);
  }
}

void pack::print(
  ostream &o
) const {

  ostream_iterator<card> oic(o, " ");
  vector<card>::const_iterator it(cards_.begin()), finis(cards_.end());
  unsigned int i(0);

  while (it != finis) {
    *oic++ = *it++;
    if (++i % card::maxValue == 0   &&   i != card::totCards) o << endl;
  }
}
